# Microservicio         Puerto
# Cliente               5002
# Repartidor            5001
# Restaurante           5000
# ESB                   5050

stages:
  - Test
  - Analyze # Sonarqube
  - Release # CD - Continuos Delivery
  - Deploy  # CD - Continuos Deploy

test_microservicioCliente:
  stage: Test
  image: python:3.6
  before_script:
  - cd ./cliente
  - pip install --no-cache-dir -r requirements.txt
  script:
  - echo "Test Microservicio Cliente"
  - python -m unittest # ejecutando test

test_microservicioRepartidor:
  stage: Test
  image: python:3.6
  before_script:
  - cd ./repartidor
  - pip install --no-cache-dir -r requirements.txt
  script:
  - echo "Test Microservicio Repartidor"
  - python -m unittest # ejecutando test

test_microservicioRestaurante:
  stage: Test
  image: python:3.6
  before_script:
  - cd ./restaurante
  - pip install --no-cache-dir -r requirements.txt
  script:
  - echo "Test Microservicio Restaurante"
  - python -m unittest # ejecutando test

release_microservicioCliente:
    stage: Release
    image: docker:latest
    only:
        - "master"
    tags:
        - docker,practica10,sa
    variables:        
        DOCKER_REGISTRY: "docker.io"    
        DOCKER_TLS_CERTDIR: "/certs"
    before_script:
    - apk add --no-cache docker-compose # install docker-compose
    - cd ./cliente
    - pwd
    # - ls ./server-eleccion/server -a
    - docker-compose down
    script:
        - docker login -u ${DOCKER_USER} -p ${DOCKER_KEY}             # registrando usuario de DockerHub
        - docker-compose build                                        # construyendo la nueva imagen
        - docker push "hugofiguer/micro-cliente:latest"               # Publicando imagen acutualizada a DockerHub
    after_script:        
        - docker logout

release_microservicioRepartidor:
    stage: Release
    image: docker:latest
    only:
        - "master"
    tags:
        - docker,practica10,sa
    variables:        
        DOCKER_REGISTRY: "docker.io"    
        DOCKER_TLS_CERTDIR: "/certs"
    before_script:
    - apk add --no-cache docker-compose # install docker-compose
    - cd ./repartidor
    - pwd
    # - ls ./server-eleccion/server -a
    - docker-compose down
    script:
        - docker login -u ${DOCKER_USER} -p ${DOCKER_KEY}             # registrando usuario de DockerHub
        - docker-compose build                                        # construyendo la nueva imagen
        - docker push "hugofiguer/micro-repartidor:latest"            # Publicando imagen acutualizada a DockerHub
    after_script:        
        - docker logout

release_microservicioRestaurante:
    stage: Release
    image: docker:latest
    only:
        - "master"
    tags:
        - docker,practica10,sa
    variables:        
        DOCKER_REGISTRY: "docker.io"    
        DOCKER_TLS_CERTDIR: "/certs"
    before_script:
    - apk add --no-cache docker-compose # install docker-compose
    - cd ./restaurante
    - pwd
    # - ls ./server-eleccion/server -a
    - docker-compose down
    script:
        - docker login -u ${DOCKER_USER} -p ${DOCKER_KEY}             # registrando usuario de DockerHub
        - docker-compose build                                        # construyendo la nueva imagen
        - docker push "hugofiguer/micro-restaurante:latest"           # Publicando imagen acutualizada a DockerHub
    after_script:        
        - docker logout

release_microservicioESB:
    stage: Release
    image: docker:latest
    only:
        - "master"
    tags:
        - docker,practica10,sa
    variables:        
        DOCKER_REGISTRY: "docker.io"    
        DOCKER_TLS_CERTDIR: "/certs"
    before_script:
    - apk add --no-cache docker-compose # install docker-compose
    - cd ./ESB
    - pwd
    # - ls ./server-eleccion/server -a
    - docker-compose down
    script:
        - docker login -u ${DOCKER_USER} -p ${DOCKER_KEY}             # registrando usuario de DockerHub
        - docker-compose build                                        # construyendo la nueva imagen
        - docker push "hugofiguer/micro-esb:latest"                   # Publicando imagen acutualizada a DockerHub
    after_script:        
        - docker logout

deploy_microservicios:
    stage: Deploy
    only:
        - "master" 
    image: docker/compose:latest
    environment: 
        name: production  
        url: http://104.154.172.20/
    tags:
        - docker,practica10,sa
    before_script:
    - docker version
    - docker-compose version
    - docker-compose down
    script:
        - docker-compose up -d --build # levantando el microservicio
